<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (72)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="mixins">Mixins</h1>
    <p>
      In JavaScript we can only inherit from a single object. There can be only
      one <code>[[Prototype]]</code> for an object. And a class may extend only
      one other class.
    </p>
    <p>
      But sometimes that feels limiting. For instance, we have a class
      <code>StreetSweeper</code> and a class <code>Bicycle</code>, and want to
      make their mix: a <code>StreetSweepingBicycle</code>.
    </p>
    <p>
      Or we have a class <code>User</code> and a class
      <code>EventEmitter</code> that implements event generation, and we’d like
      to add the functionality of <code>EventEmitter</code> to
      <code>User</code>, so that our users can emit events.
    </p>
    <p>There’s a concept that can help here, called “mixins”.</p>
    <p>
      As defined in Wikipedia, a
      <a href="https://en.wikipedia.org/wiki/Mixin">mixin</a> is a class
      containing methods that can be used by other classes without a need to
      inherit from it.
    </p>
    <p>
      In other words, a <em>mixin</em> provides methods that implement a certain
      behavior, but we do not use it alone, we use it to add the behavior to
      other classes.
    </p>
    <h2 id="a-mixin-example">A mixin example</h2>
    <p>
      The simplest way to implement a mixin in JavaScript is to make an object
      with useful methods, so that we can easily merge them into a prototype of
      any class.
    </p>
    <p>
      For instance here the mixin <code>sayHiMixin</code> is used to add some
      “speech” for <code>User</code>:
    </p>
    <p>
      ``<code>js run *!* // mixin */!* let sayHiMixin = { sayHi() { alert(</code
      >Hello ${this.name}<code>); }, sayBye() { alert(</code>Bye ${this.name}`);
      } };
    </p>
    <p>
      <em>!</em> // usage: <em>/!</em> class User { constructor(name) {
      this.name = name; } }
    </p>
    <p>// copy the methods Object.assign(User.prototype, sayHiMixin);</p>
    <p>// now User can say hi new User(“Dude”).sayHi(); // Hello Dude! ```</p>
    <p>
      There’s no inheritance, but a simple method copying. So
      <code>User</code> may inherit from another class and also include the
      mixin to “mix-in” the additional methods, like this:
    </p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="kw">class</span> User <span class="kw">extends</span> Person <span class="op">{</span></a>
<a class="sourceLine" id="cb1-2" title="2">  <span class="co">// ...</span></a>
<a class="sourceLine" id="cb1-3" title="3"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-4" title="4"></a>
<a class="sourceLine" id="cb1-5" title="5"><span class="va">Object</span>.<span class="at">assign</span>(<span class="va">User</span>.<span class="at">prototype</span><span class="op">,</span> sayHiMixin)<span class="op">;</span></a></code></pre>
    </div>
    <p>Mixins can make use of inheritance inside themselves.</p>
    <p>
      For instance, here <code>sayHiMixin</code> inherits from
      <code>sayMixin</code>:
    </p>
    <p>```js run let sayMixin = { say(phrase) { alert(phrase); } };</p>
    <p>
      let sayHiMixin = { <strong>proto</strong>: sayMixin, // (or we could use
      Object.setPrototypeOf to set the prototype here)
    </p>
    <p>
      sayHi() { <em>!</em> // call parent method <em>/!</em> super.say(<code
        >Hello ${this.name}</code
      >); // (<em
        >) }, sayBye() { super.say(<code>Bye ${this.name}</code>); // (</em
      >) } };
    </p>
    <p>class User { constructor(name) { this.name = name; } }</p>
    <p>// copy the methods Object.assign(User.prototype, sayHiMixin);</p>
    <p>// now User can say hi new User(“Dude”).sayHi(); // Hello Dude! ```</p>
    <p>
      Please note that the call to the parent method
      <code>super.say()</code> from <code>sayHiMixin</code> (at lines labelled
      with <code>(*)</code>) looks for the method in the prototype of that
      mixin, not the class.
    </p>
    <p>Here’s the diagram (see the right part):</p>
    <p><img src="mixin-inheritance.svg" /></p>
    <p>
      That’s because methods <code>sayHi</code> and <code>sayBye</code> were
      initially created in <code>sayHiMixin</code>. So even though they got
      copied, their <code>[[HomeObject]]</code> internal property references
      <code>sayHiMixin</code>, as shown in the picture above.
    </p>
    <p>
      As <code>super</code> looks for parent methods in
      <code>[[HomeObject]].[[Prototype]]</code>, that means it searches
      <code>sayHiMixin.[[Prototype]]</code>, not
      <code>User.[[Prototype]]</code>.
    </p>
    <h2 id="eventmixin">EventMixin</h2>
    <p>Now let’s make a mixin for real life.</p>
    <p>
      An important feature of many browser objects (for instance) is that they
      can generate events. Events are a great way to “broadcast information” to
      anyone who wants it. So let’s make a mixin that allows us to easily add
      event-related functions to any class/object.
    </p>
    <ul>
      <li>
        The mixin will provide a method
        <code>.trigger(name, [...data])</code> to “generate an event” when
        something important happens to it. The <code>name</code> argument is a
        name of the event, optionally followed by additional arguments with
        event data.
      </li>
      <li>
        Also the method <code>.on(name, handler)</code> that adds
        <code>handler</code> function as the listener to events with the given
        name. It will be called when an event with the given
        <code>name</code> triggers, and get the arguments from the
        <code>.trigger</code> call.
      </li>
      <li>
        …And the method <code>.off(name, handler)</code> that removes the
        <code>handler</code> listener.
      </li>
    </ul>
    <p>
      After adding the mixin, an object <code>user</code> will be able to
      generate an event <code>"login"</code> when the visitor logs in. And
      another object, say, <code>calendar</code> may want to listen for such
      events to load the calendar for the logged-in person.
    </p>
    <p>
      Or, a <code>menu</code> can generate the event <code>"select"</code> when
      a menu item is selected, and other objects may assign handlers to react on
      that event. And so on.
    </p>
    <p>Here’s the code:</p>
    <p>
      ```js run let eventMixin = { /** * Subscribe to event, usage: *
      menu.on(‘select’, function(item) { … } */ on(eventName, handler) { if
      (!this._eventHandlers) this._eventHandlers = {}; if
      (!this._eventHandlers[eventName]) { this._eventHandlers[eventName] = []; }
      this._eventHandlers[eventName].push(handler); },
    </p>
    <p>
      /** * Cancel the subscription, usage: * menu.off(‘select’, handler) */
      off(eventName, handler) { let handlers = this._eventHandlers?.[eventName];
      if (!handlers) return; for (let i = 0; i &lt; handlers.length; i++) { if
      (handlers[i] === handler) { handlers.splice(i–, 1); } } },
    </p>
    <p>
      /** * Generate an event with the given name and data *
      this.trigger(‘select’, data1, data2); */ trigger(eventName, …args) { if
      (!this._eventHandlers?.[eventName]) { return; // no handlers for that
      event name }
    </p>
    <pre><code>// call the handlers
this._eventHandlers[eventName].forEach((handler) =&gt;
  handler.apply(this, args)
);</code></pre>
    <p>}, }; ```</p>
    <ul>
      <li>
        <code>.on(eventName, handler)</code> – assigns function
        <code>handler</code> to run when the event with that name occurs.
        Technically, there’s an <code>_eventHandlers</code> property that stores
        an array of handlers for each event name, and it just adds it to the
        list.
      </li>
      <li>
        <code>.off(eventName, handler)</code> – removes the function from the
        handlers list.
      </li>
      <li>
        <code>.trigger(eventName, ...args)</code> – generates the event: all
        handlers from <code>_eventHandlers[eventName]</code> are called, with a
        list of arguments <code>...args</code>.
      </li>
    </ul>
    <p>Usage:</p>
    <p>
      ```js run // Make a class class Menu { choose(value) {
      this.trigger(“select”, value); } } // Add the mixin with event-related
      methods Object.assign(Menu.prototype, eventMixin);
    </p>
    <p>let menu = new Menu();</p>
    <p>
      // add a handler, to be called on selection: <em>!</em> menu.on(“select”,
      value =&gt; alert(<code>Value selected: ${value}</code>)); <em>/!</em>
    </p>
    <p>
      // triggers the event =&gt; the handler above runs and shows: // Value
      selected: 123 menu.choose(“123”); ```
    </p>
    <p>
      Now, if we’d like any code to react to a menu selection, we can listen for
      it with <code>menu.on(...)</code>.
    </p>
    <p>
      And <code>eventMixin</code> mixin makes it easy to add such behavior to as
      many classes as we’d like, without interfering with the inheritance chain.
    </p>
    <h2 id="summary">Summary</h2>
    <p>
      <em>Mixin</em> – is a generic object-oriented programming term: a class
      that contains methods for other classes.
    </p>
    <p>
      Some other languages allow multiple inheritance. JavaScript does not
      support multiple inheritance, but mixins can be implemented by copying
      methods into prototype.
    </p>
    <p>
      We can use mixins as a way to augment a class by adding multiple
      behaviors, like event-handling as we have seen above.
    </p>
    <p>
      Mixins may become a point of conflict if they accidentally overwrite
      existing class methods. So generally one should think well about the
      naming methods of a mixin, to minimize the probability of that happening.
    </p>
  </body>
</html>
